﻿Ext.define('App.Control.Kivii.Finances.Payment.Import.Uploader', {
    extend: 'Ext.form.Panel',
    config: {
        uploadPath: null,
        description: null
    },
    viewModel: {
        data: {
            _formIsValid: false,
            _description: '请选择要上传的文件!'
        }
    },
    updateDescription: function(_value) {
        var _me = this,
            _vm = _me.getViewModel();
        _vm.set('_description', _value);
        return _value;
    },
    layout: 'form',
    bodyPadding: 0,
    tbar:[{
        margin: '0 0 -9 3',
        xtype: 'displayfield',
        bind: {
            value: '{_description}'
        },
        fieldStyle: {
            fontSize: '20px'
        }

    }],
    items: [{
        xtype: "fileuploadfield",
        accept:'.xlsx',
        labelWidth: 60,
        fieldLabel: "选择文件",
        allowBlank: false,
        buttonConfig: {
            text: '选择...'
        }
    }],
    buttons: [{
        text: "重置",
        iconCls: 'x-fa fa-refresh',
        handler: '_onResetForm'
    }, {
        text: "上传",
        iconCls: 'x-fa fa-upload',
        handler: '_onSaveEntity',
        bind: {
            disabled: '{!_formIsValid}'
        }
    }],
    listeners: {
        validitychange: '_onFormValidityChange'
    },
    controller: {
        _onResetForm: function(_ctrl) {
            var _me = this;
            _me.getView().getForm().reset();
        },
        _onFormValidityChange: function(_ctrl, _valid) {
            var _me = this;
            var _vm = _me.getViewModel();
            _vm.set('_formIsValid', _valid);
        },
        _onSaveEntity: function() {
            var _me = this;
            var _view = _me.getView();
            var _form = _view.getForm();
            var _vm = _me.getViewModel();
            _view.mask('数据通讯中...');
            _form.submit({
                url: _view.uploadPath,
                success: function(_form, _action) {
                    _view.unmask();
                    var _rtns = Ext.decode(_action.response.responseText);
                    _view.fireEvent('uploadSucceed', _view, _rtns);
                },
                failure: function(_form, _action) { //submit方法要求返回时有success:true，不然就不能调用success方法，
                    _view.unmask();
                    var _rtns = Ext.decode(_action.response.responseText);
                    _view.fireEvent('uploadFailured', _view,_rtns);
                }
            });
        }
    }
});