﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Kivii.Finances.Entities
{
    [Api(Description = "分析")]
    public class Analysis
    {
        public string Summary { get; set; }

        public string Remark { get; set; }

        public string OwnerName { get; set; }

        public Guid OwnerKvid { get; set; }

        public AnalysisType AnalysisType { get; set; }

        public DateTime BeginTime { get; set; }

        public DateTime EndTime { get; set; }

        public string Type { get; set; }

        public decimal AmountPlan { get; set; }

        public decimal Amount { get; set; }

        public decimal AmountSettlement { get; set; }

        public decimal AmountInvoice { get; set; }

        public decimal AmountNotInvoice { get; set; }

        public decimal AmountPayment { get; set; }

        public decimal AmountNotSplit { get; set; }
        public decimal AmountSplit { get; set; }

        public decimal AmountRefund { get; set; }

        public decimal AmountUnBiz { get; set; }

        public decimal AmountUsed { get; set; }

        public decimal AmountNotUsed { get; set; }

        public decimal AmountUnpaid { get; set; }

        public decimal AmountOffset { get; set; }

        public int QuantityPlan { get; set; }

        public int Quantity { get; set; }

        public int QuantityInvoice { get; set; }
        public int QuantityNotInvoice { get; set; }

        public int QuantitySettlement { get; set; }

        public int QuantityPayment { get; set; }

        public int QuantityNotSplit { get; set; }
        public int QuantitySplit { get; set; }

        public int QuantityRefund { get; set; }

        public int QuantityUnBiz { get; set; }

        public int QuantityUsed { get; set; }
        public int QuantityNotUsed { get; set; }

        public int QuantityUnpaid { get; set; }

        public int QuantityOffset { get; set; }
    }

    /// <summary>
    /// 分析类型,默认按月,支持: 年,月,日,季度
    /// </summary>
    public enum AnalysisType
    {
        Unsupported = 0,
        Month,
        Day,
        Season,
        Year
    }
}
